EDIT - task #4232

Check all Comparators for fulfilling the Comparator contract
06/02/2014 03:46 PM - Andreas Mdller
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 4.6

Severity: critical

Description

Hi Everybody,

The issue raised with http://dev.e-taxonomy.eu/trac/ticket/4230 <http://dev.e-taxonomy.eu/trac
/ticket/4230> and some other tickets (#4226, #4114, #3333) is highly critical with Java 7+ and e
verybody should be aware of it when responsible for writing Comparators.

The Comparator contract requires that

1) compare(01,02) == 0 must be true and ONLY be true if 01.equals(02).

2) sgn(compare(o1,02)) = -sgn(compare(02,01)) (symmetrie)

3) compare function must be transitive

Checking our comparators in cdmlib-model (and some others) | realized that almost none of our comparators does fulfill all of these
conditions. So | would like to remind us all to be aware of this. Java 7 is more sensitive on these conditions as the new TimSort sort

algorithm throws exceptions otherwise.

Condition 1) for CdmBase objects usually means that compare(o1,02) MUST return 0 whenever 2 objects do have the same uuid.
This can easily be managed by checking if this is the case as a very first step and returning 0 if yes.

However, the second implication is more tricky. You must guarantee that in no other cases 0 is returned.
So having something like
Compare (01,02) {
x1 = ol.getX();
x2 = ol.getX();
return x1l.compare (x2);

}

which | have seen in many comparators is generally WRONG because x1.compare(x2) will usually not guarantee that
o1.getUuid.equals(o2.getUuid()).

A concrete example are taxon comparators which send the comparison to the attached names. In case both taxa do use the exact
same name this will definetly return 0 even if name.compare(name) is correctly implemented. However, the taxa do not have the
same uuid and therefore they should not return 0.

A possible correct implementation could do

int result = namel.compare (name2);
'=0){
return result

if (result
lelse{
return taxonl.getUuid () .compare (taxon2.getUuid());

}

Condition 2) and 3) require more individual handling. But be aware that your ordering must never be arbitrary. E.g.
compare (namel, name?2) {
rankl = namel.getRank ()
rank2 = name?2.getRank ()
if (rankl == null) return 1;
if (rank2 == null) return -1;

will always be INVALID as compare(name1, name2) == compare(name2, name1) == 1 is possible for both ranks == null, but is
against the symmetrie contract (2).

So EVERYONE who will write comparators or did so in the past please carefully check your code for correct implementations.

@Katja: we both will need to check this systematically in CdmLib for old code. Also a very critical method is e.g.
IdentifiablyEntity.compare()

Cheers,
Andreas M.
P.S:

Be aware that 2) and 3) and partly 1) also hold for the Comparable interface (comparetTo() method).

Related issues:
Copied to EDIT - bug #6311: Refactor IdentifiableEntity.compareTo method Rejected

Associated revisions

Revision 7229f9d4 - 02/09/2017 01:09 PM - Katja Luther

ref #4232: made some changes to fullfill the comparator contract

Revision fc758deb - 02/09/2017 01:31 PM - Katja Luther

ref #4232: adapt comparator to comaparator contract

Revision bdcfdeab - 02/09/2017 01:37 PM - Katja Luther

ref #4232: adapt comparator of filteredSelection dialogs to fulfill the comparator contract

Revision df366db5 - 02/09/2017 02:29 PM - Katja Luther

ref #4232: some more comparators to adapt

Revision 2ebeb1a9 - 02/09/2017 02:33 PM - Patrick Plitzner

ref #4232 refactoring for comparator

Revision 39d13a15 - 03/10/2017 12:17 PM - Andreas Miiller

ref #4232 Improve OrderedTermBase.performCompareTo to include vocabulary information

Revision 375d001e - 03/10/2017 12:54 PM - Andreas Miiller

ref #4232 implement comparator contract for DistributionNodeByArealabelComparator

History

#1 - 06/02/2014 03:47 PM - Andreas Miiller
some fixes done with r20934, r20936-20939

#2 - 03/24/2015 03:48 PM - Andreas Kohlbecker
- Target version changed from cdmlib RELEASE 3.5.0 to cdmlib RELEASE 3.5.1

moving tickets to next milestone

#3 - 05/04/2015 05:08 PM - Andreas Miiller
- Target version changed from cdmlib RELEASE 3.5.1 to cdmlib RELEASE 3.5.2
move open 3.5.1 tickets to next milestone after release

#4 - 08/11/2015 11:10 AM - Katja Luther

- Status changed from New to In Progress

The IdentifiableEntity.compareTo method needs to be updated.

First of all | added the test of equality of the uuids.

Next step would be the problem if the name of two taxa is the same and the sec is the same (for example both taxa don't have a sec ref) the method

would return 0, but this should happen only if the taxa are really equal. Normaly this should not happen but may be the last comparison should be a
comparison of the created or updated date?

#5 - 12/18/2015 12:38 PM - Andreas Miiller
- Target version changed from cdmlib RELEASE 3.5.2 to Unassigned CDM tickets

#6 - 01/05/2017 03:22 PM - Andreas Miiller
- Copied to bug #6311: Refactor IdentifiableEntity.compareTo method added

#7 - 01/05/2017 03:23 PM - Andreas Miuller

- Description updated
moved IdentifiableEntity.compareTo issue to new ticket #6311

#8 - 01/05/2017 03:24 PM - Andreas Miuller

- Target version changed from Unassigned CDM tickets to Release 4.6
Please report results of current effort and maybe check for new Comparators

#9 - 02/09/2017 11:59 AM - Katja Luther

- File comparatorlist.xlsx added

#10 - 02/09/2017 01:13 PM - Katja Luther

- File comparatorlist.xlsx added

#11 - 02/09/2017 01:13 PM - Katja Luther

- File deleted (comparatorlist.xlsx)

#12 - 03/10/2017 12:20 PM - Andreas Miiller
KL: AreaNodeComparator in FloraCubaCondensedDistributionComposer
Hier werden die namedAreas verglichen, indem die compareTo Methode von OrderedTermBase aufgerufen wird. Wenn aber jetzt die beiden Terme

nicht im gleichen Vokabular enthalten sind, werden sie trotzdem nach dem orderlndex sortiert, dieser kann dann ja gleich sein, weil sie in
unterschiedlichen Vokabularen sind. D.h. die compare Methode gibt 0 bei nicht gleichen Termen zuriick, oder??

#13 - 03/10/2017 12:21 PM - Andreas Miiller

Andreas Milller wrote:
KL: AreaNodeComparator in FloraCubaCondensedDistributionComposer

Hier werden die namedAreas verglichen, indem die compareTo Methode von OrderedTermBase aufgerufen wird. Wenn aber jetzt die beiden
Terme nicht im gleichen Vokabular enthalten sind, werden sie trotzdem nach dem orderindex sortiert, dieser kann dann ja gleich sein, weil sie in
unterschiedlichen Vokabularen sind. D.h. die compare Methode gibt 0 bei nicht gleichen Termen zuriick, oder??

Letztlich wird OrderedTermBase.performCompareTo mit skipVocabularyCheck = false aufgerufen. Daher werden alle Falle mit unterschiedlichen
Vokabularen Uber eine Exception abgefangen und fihren zu keinem Ergebnis, auch nicht zu einem falschen. Somit wir der Comparator Contract m.E.
nicht verletzt.

Trotzdem ist das ein bisschen gefahrlich, falls wir an der Implementierung mal ein bisschen was &ndern. Daher habe ich in
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/revisions/39d13a15932e979559b21bf484a122454dd00f38 die Methode ein bisschen
angepasst. Kannst du das bitte gegenchecken, auf Richtigkeit und auf mégliche NPEs oder Ahnliches.
#14 - 03/10/2017 12:22 PM - Andreas Miiller
KL: Bei DistributionNodeByAreal.abelComparator

Wiirde hier auch nochmal einen weiteren Vergleich einfligen, wenn die Label gleich sind, oder kommt das nicht vor?

#15 - 03/10/2017 12:57 PM - Andreas Miiller

Andreas Muller wrote:

KL: Bei DistributionNodeByArealabelComparator

Wiirde hier auch nochmal einen weiteren Vergleich einfiigen, wenn die Label gleich sind, oder kommt das nicht vor?

Ja vermutlich hast du Recht. Ich habe den Comparator angepasst und auch einen Test geschrieben:
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/revisions/375d001e7222d435¢799e9232e856fb98de32e1d

#16 - 03/10/2017 12:58 PM - Andreas Miiller
- Tracker changed from bug to task

- Status changed from In Progress to Resolved

Probably we can close this ticket now?

#17 - 03/10/2017 01:11 PM - Katja Luther

- Status changed from Resolved to Closed

Yes then we can close the ticket.

#18 - 03/11/2017 10:52 PM - Andreas Miiller
- % Done changed from 0 to 100

- Private changed from Yes to No

Files
comparatorlist.xlsx 11.2 KB 02/09/2017 Katja Luther
